

#include <rex/syscall.h>

#define PIC_NAME 2
#define PIC_DATA 3

#define REG_BANK2_LO  0x03
#define REG_BANK2_HI  0x04
#define DISPLAY_START 0xa000
#define BM_START      0x3e
#define BL_LIN        30
#define BM_BLP        32

typedef struct {
unsigned int year;
unsigned char month;
unsigned char day;
unsigned char week;
} DATE;

typedef struct {
unsigned char hour;
unsigned char minute;
unsigned char second;
} TIME;

void cls(void);

void init_rand(void)
{
  DATE fecha;
  TIME hora;
  int sem;

  DsTimeGet(&fecha,&hora);
  sem = hora.second;
  sem += hora.minute<<6;
  sem += hora.hour<<12;

  srand(sem);
}

void swap(byte *a, byte *b)
{
  static byte aux;

  aux = *a;
  *a = *b;
  *b = aux;
}

void desordenar(char *elem)
{
  byte i;

  for (i = 0; i<120; i++) elem[i] = i;
  for (i = 0; i<120; i++) swap(&elem[i],&elem[(rand()%120)]);
}

byte grafico(char *nombre)
{
  unsigned short len_ret;
  char *nom, buf[BL_LIN], desor[120];
  byte aux_REG_BANK2_HI, aux_REG_BANK2_LO, y, x;
  int dbhandle, map;

  dbhandle = DbOpen(DBID_PICTURE);
  if (DbFindRecord(dbhandle,1,1,0,0)!=1) { DbClose(dbhandle); return FALSE; }

  for (;;)
  {
    DbReadField(dbhandle,PIC_NAME,&nom);
    if (!strcmp(nom,nombre)) break;
    if (DbNextRecord(dbhandle)!=1) { DbClose(dbhandle); return FALSE; }
  }

  cls();

  desordenar(desor);
  for (y = 0; y<120; y++)
  {
    map = DISPLAY_START+BL_LIN*(119-desor[y]);
    DbReadText(dbhandle,PIC_DATA,BM_START+BM_BLP*desor[y],BM_BLP,&len_ret,buf);
    aux_REG_BANK2_HI = REGISTER_READ(REG_BANK2_HI);
    aux_REG_BANK2_LO = REGISTER_READ(REG_BANK2_LO);
    REGISTER_WRITE(REG_BANK2_HI,0x10);
    REGISTER_WRITE(REG_BANK2_LO,0x00);
    for (x = 0; x<BL_LIN; x++) *(char *)(map++) = buf[x];
    REGISTER_WRITE(REG_BANK2_HI,aux_REG_BANK2_HI);
    REGISTER_WRITE(REG_BANK2_LO,aux_REG_BANK2_LO);
  }
  DbClose(dbhandle);
  return TRUE;
}
